summaryrefslogtreecommitdiffstats
path: root/gettext-tools/tests/format-python-brace-2
diff options
context:
space:
mode:
authorDaiki Ueno <ueno@gnu.org>2013-04-22 20:01:12 +0900
committerDaiki Ueno <ueno@gnu.org>2013-04-26 18:54:39 +0900
commit6543f644bf11c00a19843971e1858edb3d870442 (patch)
tree313a4a3eb498ae30e75ad99faf1badcf06956c9b /gettext-tools/tests/format-python-brace-2
parent4ee0aa06f7108395ea62df10c3fbf2117c44d891 (diff)
downloadexternal_gettext-6543f644bf11c00a19843971e1858edb3d870442.zip
external_gettext-6543f644bf11c00a19843971e1858edb3d870442.tar.gz
external_gettext-6543f644bf11c00a19843971e1858edb3d870442.tar.bz2
Support Python brace format.
Diffstat (limited to 'gettext-tools/tests/format-python-brace-2')
-rwxr-xr-xgettext-tools/tests/format-python-brace-270
1 files changed, 70 insertions, 0 deletions
diff --git a/gettext-tools/tests/format-python-brace-2 b/gettext-tools/tests/format-python-brace-2
new file mode 100755
index 0000000..734baa3
--- /dev/null
+++ b/gettext-tools/tests/format-python-brace-2
@@ -0,0 +1,70 @@
+#! /bin/sh
+
+# Test checking of Python brace format strings.
+
+tmpfiles=""
+trap 'rm -fr $tmpfiles' 1 2 3 15
+
+tmpfiles="$tmpfiles f-pyb-2.data"
+cat <<\EOF > f-pyb-2.data
+# Valid: same named arguments
+msgid "abc{date}{time}"
+msgstr "xyz{date}{time}"
+# Valid: permutation
+msgid "abc{x3}{x1}{x2}def"
+msgstr "xyz{x2}{x1}{x3}"
+# Invalid: missing argument
+msgid "abc{x2}def{x1}"
+msgstr "xyz{x1}"
+# Invalid: missing argument
+msgid "abc{x1}def{x2}"
+msgstr "xyz{x2}"
+# Valid: added argument (valid since "{zoo}" expands to itself)
+msgid "abc{foo}def"
+msgstr "xyz{foo}uvw{zoo}"
+# Valid: multiple reuse of same argument
+msgid "{foo} {bar} {baz}"
+msgstr "{baz} {bar} {foo} {bar}"
+# Valid: single reuse of same argument
+msgid "{baz} {bar} {foo} {bar}"
+msgstr "{foo} {bar} {baz}"
+EOF
+
+: ${MSGFMT=msgfmt}
+n=0
+while read comment; do
+ read msgid_line
+ read msgstr_line
+ n=`expr $n + 1`
+ tmpfiles="$tmpfiles f-pyb-2-$n.po f-pyb-2-$n.mo"
+ cat <<EOF > f-pyb-2-$n.po
+#, python-brace-format
+${msgid_line}
+${msgstr_line}
+EOF
+ fail=
+ if echo "$comment" | grep 'Valid:' > /dev/null; then
+ if ${MSGFMT} --check-format -o f-pyb-2-$n.mo f-pyb-2-$n.po; then
+ :
+ else
+ fail=yes
+ fi
+ else
+ ${MSGFMT} --check-format -o f-pyb-2-$n.mo f-pyb-2-$n.po 2> /dev/null
+ if test $? = 1; then
+ :
+ else
+ fail=yes
+ fi
+ fi
+ if test -n "$fail"; then
+ echo "Format string checking error:" 1>&2
+ cat f-pyb-2-$n.po 1>&2
+ exit 1
+ fi
+ rm -f f-pyb-2-$n.po f-pyb-2-$n.mo
+done < f-pyb-2.data
+
+rm -fr $tmpfiles
+
+exit 0